﻿//-------------------------------------------------------------
// Intellisense Support for Gadget Development
// MicrosoftAjax.debug.js is property of Microsoft Corporation
// Sidebar.Intellisense.js was developed for Jonas Folles
// http://jonas.follesoe.no/JavaScriptIntelliSenseForTheVistaSidebarObjectModel.aspx
//-------------------------------------------------------------
///<reference path="MicrosoftAjax.debug.js" />
///<reference path="Sidebar.IntelliSense.js" />
//-------------------------------------------------------------
// This file has the prototype for the principal Events
// that gadget can firing. You should personalize them to your
// specific gadget
//-------------------------------------------------------------
//-------------------------------------------------------------
// Wiring Gadget Events with javascript functions
//-------------------------------------------------------------

if (typeof (System) != 'undefined') 
{
    //when the gadget is undocked or docked------
    System.Gadget.onUndock = CheckDockState;
    System.Gadget.onDock = CheckDockState;
    //wiring the setting page
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = settingsClosed;
    //Attach Event handles for the flyout
    System.Gadget.Flyout.onHide = flyoutHiding;
    //System.Gadget.Flyout.onShow = showFlyout;
    
}

//-------------------------------------------------------------
// Here you can define variables

var updateTimer;
var toggle = true;
var NoInetConnectionFlag = 0;

//-------------------------------------------------------------
//-------------------------------------------------------------
// OnPageLoad: fires when the page is loaded for the first time
//-------------------------------------------------------------
function OnPageLoad()
{
	///<summary>Place here the necessary code to initialize your form </summary>
	redrawGadget();
//	CreateFlyOutButton(); 
}

//---check if the gadget is undocked or docked---
// And configure the gadget for the present state
function CheckDockState()
{
    if (typeof (System) == 'undefined') { return; }
    if (!System.Gadget.docked)
    {
        UndockedState();
    }
    else
    {
        DockedState();
    }
}

//---the gadget is docked---
function DockedState()
{
    //set the width and height of the page docked
    with (document.body.style)
    {
        width  = "110px"; //max value! 
        height = "138px";
    }
    with (divImg.style)
    {
		width = "110px"; 
	}
	redrawGadget();
	CreateFlyOutButton(); 
}

//---the gadget is undocked---
//Format the gadget to the undocking form
function UndockedState()
{
    // set the page to hight and width of th docked page
    with (document.body.style)
    {
        width = "150px";
        height = "230px";
    }
    with (divImg.style)
    {
		width = "150px"; 
	}
	redrawGadget();
	CreateFlyOutButton(); 
}

//------------------------------------------------------------
// Setting Closed event
//------------------------------------------------------------
//---fires when the settings page is closed---
function settingsClosed(event)
{
    ///<summary> Fired when the setting is closed, use this to get the returned values from setting </summary>
    // This question give you the information if the setting page
    //was closed when OK button was clicked
    if (event.closeAction == event.Action.commit)
    {
        redrawGadget();
    }
}

//------------------------------------------------------------
// Attention to flyout Events
//------------------------------------------------------------
function showAbout()
{
    ///<summary> Use this function to show the "about" form flyout</summary>
    if (typeof (System) != 'undefined')
    {
        System.Gadget.Flyout.file = "about.html";
        System.Gadget.Flyout.show = true;
    }
}

function showFlyout()
{
    ///<summary> Use this function to show the "flyout" form flyout</summary>
    if (typeof (System) != 'undefined')
    {
    	System.Gadget.Flyout.file = "flyout.html";
        System.Gadget.Flyout.show = true;
    }
}

//when the flyout closes---
function flyoutHiding()
{
    ///<summary> add here the logic to identify is the flyout was closed </summary>
}

function CreateFlyOutButton()
{
    ///<summary> Create the button to call the about and flyout forms flyouts.</summary>
	//Set flyout buttons
    if (System.Gadget.docked)
    {
		container = document.getElementById("buttonSection");
		document.getElementById("buttonSection2").innerHTML = "";
    } else {
		container = document.getElementById("buttonSection2");
		document.getElementById("buttonSection").innerHTML = "";
    }	
	//Flyout GRAPHIC
	var bflyout = document.createElement("input");
	bflyout.setAttribute("id", "bflyout");
	bflyout.setAttribute("type", "button");
	bflyout.setAttribute("value", " ? ");
	bflyout.setAttribute("title", "Help");
	bflyout.onclick = showFlyout;
	container.appendChild(bflyout);
	//flyout ABOUT....
	var babout = document.createElement("input");
	babout.setAttribute("id", "babout");
	babout.setAttribute("type", "button");
	babout.setAttribute("value", " . ");
	babout.setAttribute("title", "About");
	babout.onclick = showAbout;
	container.appendChild(babout);
}

// Main function	
function redrawGadget()
{	
	var ipAddress = System.Gadget.Settings.read("ipAddress");
	if (ipAddress == "") ipAddress = "192.168.0.1";
	var refRate = System.Gadget.Settings.read("refRate");
	if (refRate == "") refRate = "60";
	
	clearTimeout(updateTimer);
	updateTimer = setTimeout('redrawGadget();', 1000 * refRate);
	
	var url = "http://" + ipAddress + "/fap_meter/";  // for FAP stats
//	var xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	var xmlhttp = new ActiveXObject("MSXML2.ServerXMLHTTP"); 
//	xmlhttp.open("GET", url, false); 
	xmlhttp.open("GET", url, true);
	xmlhttp.onreadystatechange=function()
	{
		if (xmlhttp.readyState==4)
		{
			if (xmlhttp.status == 200)
			{
				InetConnectionIsOK();
				parse_fapmeter(xmlhttp.responseText);
			} else {
				NoInetConnection();
			}	
		}
	}
//	xmlhttp.send(""); 
	xmlhttp.send(null);	
//	document.writeln(xmlhttp.responseText); 
//	xmlhttp = null; 

	var url2 = "http://" + ipAddress + "/sys_status/";  // for signal strength
//	var xmlhttp2 = new ActiveXObject("Microsoft.XMLHTTP");
	var xmlhttp2 = new ActiveXObject("MSXML2.ServerXMLHTTP"); 
//	xmlhttp2.open("GET", url2, false); 
	xmlhttp2.open("GET", url2, true); 
	xmlhttp2.onreadystatechange=function()
	{
		if (xmlhttp2.readyState==4)
		{
			if (xmlhttp2.status == 200)
			{
				InetConnectionIsOK();
				parse_sysstatus(xmlhttp2.responseText);
			} else {
				NoInetConnection();
			}	
		}
	}
	xmlhttp2.send(null);	
//	document.writeln(xmlhttp2.responseText); 	
//	xmlhttp2 = null; 

	var url3 = "http://" + ipAddress + "/sys_info/";  // for account info
//	var xmlhttp3 = new ActiveXObject("Microsoft.XMLHTTP");
	var xmlhttp3 = new ActiveXObject("MSXML2.ServerXMLHTTP"); 
//	xmlhttp3.open("GET", url3, false); 
	xmlhttp3.open("GET", url3, true); 
	xmlhttp3.onreadystatechange=function()
	{
		if (xmlhttp3.readyState==4)
		{
			if (xmlhttp3.status == 200)
			{
				InetConnectionIsOK();
				parse_sysinfo(xmlhttp3.responseText);
			} else {
				NoInetConnection();
			}	
		}
	}
	xmlhttp3.send(null);	
//	document.writeln(xmlhttp3.responseText); 	
//	xmlhttp3 = null; 

	var url4 = "http://" + ipAddress + "/status/status_bar.html";  // for account info
//	var xmlhttp4 = new ActiveXObject("Microsoft.XMLHTTP");
	var xmlhttp4 = new ActiveXObject("MSXML2.ServerXMLHTTP"); 
//	xmlhttp4.open("GET", url4, false); 
	xmlhttp4.open("GET", url4, true); 
	xmlhttp4.onreadystatechange=function()
	{
		if (xmlhttp4.readyState==4)
		{
			if (xmlhttp4.status == 200)
			{
				InetConnectionIsOK();
				parse_statusbar(xmlhttp4.responseText);
			} else {
				NoInetConnection();
			}	
		}
	}
	xmlhttp4.send(null);	
//	document.writeln(xmlhttp4.responseText); 	
//	xmlhttp4 = null; 
}

function parse_fapmeter(xmlData)  // deal with FAP data when it's available
{
//	var allowance = xmlData.search(/Plan\sAllowance\s\(Mbytes\)<\/td><td\salign=center><div\sclass=text>/g);
	var allowancestr = xmlData.substr(xmlData.search(/Plan\sAllowance/g) + 61, 3+6);
	allowancestr = allowancestr.substr(0, allowancestr.search(/<\/td/g));
//	var remaining = xmlData.search(/Allowance\sRemaining\(Mbytes\)<\/td><td\salign=center><div\sclass=text>/g);
	var remainingstr = xmlData.substr(xmlData.search(/Allowance\sRemaining\(M/g) + 65, 3+6);
	remainingstr = remainingstr.substr(0, remainingstr.search(/<\/td/g));
//	var remainingpct = xmlData.search(/Allowance\sRemaining\(%\)\sis\sshown\sin\sgreen<\/td><td\salign=center><div\sclass=text>/g);
	var remainingpctstr = xmlData.substr(xmlData.search(/Allowance\sRemaining\(%/g) + 78, 3+6);
	remainingpctstr = remainingpctstr.substr(0, remainingpctstr.search(/<\/td/g));
	if (remainingpctstr == "100%") remainingpctstr = "Full";
//	var timetill = xmlData.search(/Time\sUntil\sAllowance\sRefill\(Hours:Minutes\)<\/td><td\salign=center><div\sclass=text>/g);
	var timetill = xmlData.search(/Time\sUntil/g);
	if (timetill != -1) {
		var timetillstr = xmlData.substr(timetill + 80, 3+6);
		timetillstr = timetillstr.substr(0, timetillstr.search(/<\/td/g));
	}
//	var clickhere = xmlData.search(/Click\s<a href=/g);
	var clickherestr = xmlData.substr(xmlData.search(/Click/g) + 14, 75+6);
	clickherestr = clickherestr.substr(0, clickherestr.search(/>/g));

// a widget to show we're working
	toggle = ! toggle;
	if (toggle) {
		var togglestr = "-";
	} else {
		var togglestr = "|";
	}
	
//	var tmptext = remainingstr + " Mb (" + remainingpctstr + ")\nremaining of\n"; 
//	tmptext += allowancestr + " Mb allowance\n";
	var timefullmin = parseInt(((allowancestr - remainingstr) / (allowancestr / 24) - parseInt((allowancestr - remainingstr) / (allowancestr / 24))) * 60);
	var timefullhr = parseInt((allowancestr - remainingstr) / (allowancestr / 24));
	if (timefullmin < 10) timefullmin = "0" + timefullmin;
//	if (timefullhr.NAN) timefullhr = "??";
//	if (timefullmin.NAN) timefullmin = "??";
	var timefull = timefullhr + "hr " + timefullmin + "min";
	if (timetill != -1) {   // we are fap'ed
//		tmptext += timetill;
		var delimiter = timetillstr.search(/:/g);
		var timetillstr = timetillstr.substring(0, delimiter) + "hr " + timetillstr.substr(delimiter+1, 2) + "min";
//		tmptext += "UnFAPed in " + timetillstr + "\n";
		remainingImg.src = "Images/ball4.png"; 
		document.getElementById("timetillTxt").innerText = "UnFAPed in " + timetillstr;	
//		document.getElementById("restoreLink").innerHTML = "<a href=\"http://services.hughesnet.com/Service_Tools/tokens/index.cfm\" target=\"_blank\">Restore Tokens</a>";		
		document.getElementById("restoreLink").innerHTML = "<a href=\"" + clickherestr + "\" target=\"_blank\">Restore Tokens</a>";		
	} else {				// we are normal
		if (remainingstr < (allowancestr * 0.2)) {	// getting low
			remainingImg.src = "Images/ball3.png";  // 20% is 75 for Pro
		} else {									// good to go
			remainingImg.src = "Images/ball2.png";
		}
		document.getElementById("timetillTxt").innerText = "Full in " + timefull;	
		document.getElementById("restoreLink").innerHTML = allowancestr + " Mb allowance";		
	}
    document.getElementById("remainingTxt").innerText = remainingstr + " Mb (" + remainingpctstr + ")";
//	tmptext += togglestr;
//    if (System.Gadget.docked)
//    {
//        document.getElementById("gadgetContent").innerText = "";
//    } else {
//		document.getElementById("gadgetContent").innerText = "\n" + tmptext + "\n";
//    }	
}

function parse_sysstatus(xmlData)  // deal with signal strength data when it's available
{
//	var signalstr = xmlData.search(/Signal\sStrength</div></td><td><div\sclass=text>/g);
	var signalstr = xmlData.substr(xmlData.search(/Signal/g) + 46, 3);	// signal is always 3 characters???

	if (signalstr < 25) {
		signalImg.src = "Images/ball4.png"; //25	
	} else if (signalstr < 40) {
		signalImg.src = "Images/ball3.png"; //40
	} else {
		signalImg.src = "Images/ball2.png";
	}
	document.getElementById("signalTxt").innerHTML = "<b>" + signalstr + "</b> Signal level";
}

function parse_statusbar(xmlData)  // deal with system status data when it's available
{
	var ipAddress = System.Gadget.Settings.read("ipAddress");
	if (ipAddress == "") ipAddress = "192.168.0.1";
//	var statusstr = xmlData.search(/System<br>Status<br><a\shref=\/sys_status\/\starget=right_frame\sonClick='showLeftMenu()'><img\ssrc=\/fs\/images\//g);
	var statusstr = xmlData.substr(xmlData.search(/System<br>Status/g) + 105, 50);
	var statusclr = statusstr.substr(0, statusstr.search(/.GIF/g));
	var statusstr = statusstr.substr(statusstr.search(/class=text>/g) + 11, statusstr.search(/<\/td/g));
	if (statusclr == "red") {
		statusImg.src = "Images/ball4.png";	
	} else if (statusclr == "yellow") {
		statusImg.src = "Images/ball3.png";
	} else {
		statusImg.src = "Images/ball2.png";
	}
	document.getElementById("statusTxt").innerHTML = "<a href=\http://" + ipAddress + "><b>" + statusstr + "</b></a>";
}

function parse_sysinfo(xmlData)  // deal with account info data when it's available
{
//    if (System.Gadget.docked)
//    {
//		document.getElementById("siteidTxt").innerText = "";
//		document.getElementById("sanTxt").innerText = "";
//		document.getElementById("serialTxt").innerText = "";
//		document.getElementById("swverTxt").innerText = "";
//		document.getElementById("natipTxt").innerText = "";
//	} else {
//		var siteid = xmlData.search(/Site\sID:</td><td><div\sclass=text>/g);  // all data ends with </td>
		var siteidstr = xmlData.substr(xmlData.search(/Site/g) + 33, 8+6);
		siteidstr = siteidstr.substr(0, siteidstr.search(/<\/td/g));
		document.getElementById("siteidTxt").innerText = siteidstr;
//		var san = xmlData.search(/SAN:</td><td><div\sclass=text>/g);
		var sanstr = xmlData.substr(xmlData.search(/SAN/g) + 29, 12+6);
		sanstr = sanstr.substr(0, sanstr.search(/<\/td/g));
		document.getElementById("sanTxt").innerText = sanstr;
//		var serial = xmlData.search(/Serial\sNumber:</td><td><div\sclass=text>/g);
		var serialstr = xmlData.substr(xmlData.search(/Serial/g) + 39, 7+6);
		serialstr = serialstr.substr(0, serialstr.search(/<\/td/g));
		document.getElementById("serialTxt").innerText = serialstr;
//		var swver = xmlData.search(/Software\sRelease:</td><td><div\sclass=text>/g);
		var swverstr = xmlData.substr(xmlData.search(/Software\sRelease/g) + 42, 8+6);
		swverstr = swverstr.substr(0, swverstr.search(/<\/td/g));
		document.getElementById("swverTxt").innerText = swverstr;
//		var natip = xmlData.search(/NAT\sIP\sAddress:</td><td><div\sclass=text>/g);
		var natipstr = xmlData.substr(xmlData.search(/NAT\sIP/g) + 40, 13+6);
		natipstr = natipstr.substr(0, natipstr.search(/<\/td/g));
		document.getElementById("natipTxt").innerText = natipstr;
//	}
}

function NoInetConnection()
{	
	if(NoInetConnectionFlag == 0)	// we have yet to find the modem
	{		
		document.getElementById("timetillTxt").innerHTML = "<b>Unable to Find Modem</b>";	
		NoInetConnectionFlag = 1;
//		TimeLastUpdate.innerText = "";
//		TempSpan.innerText = "";
//		CityNameSpan.innerText = "";
//		CondSpan.innerText = "";
//		NoInetConnectionSpan.innerHTML = lng_NoData;
//		currentImgMoon.src = "images/undefined.png";
//		currentImg.src = "images/undefined.png";

//		with (document.body.style)
//			height = (192).toString() + "px",
//			width = (129).toString() + "px",
//			background = "transparent url(/images/back_enchanged_nodata.png)";
	}

	if(NoInetConnectionFlag == 2)  // we found modem earlier
	{
		document.getElementById("timetillTxt").innerHTML = "<b>No Response from Modem</b>";	
//		TimeLastUpdate.innerHTML = "";
//		NoInetConnectionLine.innerHTML = lng_NoData;
	}
	document.getElementById("statusTxt").innerHTML = "<b>No Status</b>";	
	document.getElementById("restoreLink").innerHTML = "Retry in 5 seconds";		
	statusImg.src = "Images/ball4.png"; 
	remainingImg.src = "Images/ball4.png"; 
	signalImg.src = "Images/ball4.png";

	self.clearTimeout(updateTimer);
	updateTimer = self.setTimeout('redrawGadget();', 1000*5);  // try again in 5 seconds
}

function InetConnectionIsOK()
{
//	NoInetConnectionSpan.innerText = "";
	NoInetConnectionFlag = 2;
//	document.body.style.backgroundImage = "url(images/spacer.png)";
//	for (var i = 1; i <= 9; i++)
//		document.getElementById("dayImg" + i).style.visibility = "visible";
}
